<div>
  <div *ngIf="!showOrderTrack">
    <h1 class="title-set-map">Dispatcher M<a (click)="unhide()"
        style="color:black;text-decoration:none;cursor:text">a</a>p</h1>
    <div class="container">
      <div class="col-sm-4 col-md-4 autocomplete-width autocomplete-field-container">
        <input id="search-input" [(ngModel)]="placeFilter" class="search-set form-control" type="text"
          placeholder="Search location">
      </div>
      <div class="col-sm-2 col-md-2  autocomplete-width autocomplete-field-container">
        <div class="dropdown">
          <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown"
            aria-haspopup="true" aria-expanded="false" style="width: 100%; font-size: 11px;" class="form-control">
            Select Vehicle Status
          </button>
          <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
            <button class="dropdown-item" type="button"
              style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
              (click)="setVehicleStatusFilter('9')">
              <div class="text-center"
                style="display: inline-block; margin-left: 4px; margin-right: 4px;  background-color:rgb(41, 41, 41);width: 20px; height:auto; color: #FFF;">
                {{loggedLength}}</div>
              All active
            </button>
            <button class="dropdown-item" type="button"
              style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
              (click)="setVehicleStatusFilter('3')">
              <div class="text-center"
                style="display: inline-block; margin-left: 4px; margin-right: 4px;  background-color:rgb(41, 41, 41);width: 20px; height:auto; color: #FFF;">
                {{ loggedLength }}
              </div>
              Logged
            </button>
            <button class="dropdown-item" type="button"
              style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
              (click)="setVehicleStatusFilter('6')">
              <div class="text-center"
                style="display: inline-block; margin-left: 4px; margin-right: 4px; width: 20px; height:auto; color: #FFF;padding: 1px; background-color:rgb(59, 59, 253);">
                {{bookedLength}}</div>
              Booked
            </button>
            <button class="dropdown-item paused" type="button"
              style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
              (click)="setVehicleStatusFilter('1')">
              <div class="text-center"
                style="display: inline-block; margin-left: 4px; margin-right: 4px;  background-color:rgb(198, 67, 67);width: 20px; height:auto; color: #FFF;">
                {{offlineLength}}</div>
              Paused
            </button>
            <div class="careem">
              <button class="dropdown-item paused" type="button"
                style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
                (click)="setTripStatus(3)">
                <div class="text-center"
                  style="display: inline-block; margin-left: 4px; margin-right: 4px;  background-color:rgb(198, 67, 67);width: 20px; height:auto; color: #FFF;">
                  {{uber_careem}}</div>
                Uber/Careem
              </button>
              <button class="dropdown-item paused" type="button"
                style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
                (click)="setTripStatus(4)">
                <div class="text-center"
                  style="display: inline-block; margin-left: 4px; margin-right: 4px;  background-color:rgb(198, 67, 67);width: 20px; height:auto; color: #FFF;">
                  {{normal_pause}}</div>
                Break
              </button>
            </div>
            <button class="dropdown-item" type="button"
              style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
              (click)="setVehicleStatusFilter('5')">
              <div class="text-center"
                style="display: inline-block; margin-left: 4px; margin-right: 4px; width: 20px; height:auto; color: #FFF; background-color:rgb(67, 198, 79);">
                {{ freeLength }}
              </div>
              Free
            </button>
            <button class="dropdown-item" type="button"
              style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
              (click)="setTripStatus(1)">
              <div class="text-center"
                style="display: inline-block; margin-left: 4px; margin-right: 4px; width: 20px; height:auto; color: #FFF; background-color:rgb(77, 150, 89);">
                {{ acceptedLength }}
              </div>
              Accepted
            </button>
            <button class="dropdown-item" type="button"
              style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
              (click)="setTripStatus(2)">
              <div class="text-center"
                style="display: inline-block; margin-left: 4px; margin-right: 4px; width: 20px; height:auto; color: #FFF; background-color:rgb(67, 108, 79);">
                {{ almostFreeLength }}
              </div>
              Almost Free
            </button>
            <button class="dropdown-item" type="button"
              style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
              (click)="setVehicleStatusFilter('8')">
              <div class="text-center"
                style="display: inline-block; margin-left: 4px; margin-right: 4px; width: 20px; height:auto; color: #FFF; background-color:rgb(80, 80, 80);">
                {{logged_out}}
              </div>
              Logged Out
            </button>
            <button class="dropdown-item" type="button"
              style="display:block; font-size: 11px; text-align: left; width: 95%; background-color: #FFF"
              (click)="setVehicleStatusFilter('0')">
              <div class="text-center"
                style="display: inline-block; margin-left: 4px; margin-right: 4px; width: 20px; height:auto; color: #FFF; ">
                &nbsp;&nbsp;
              </div>
              <strong>Offline</strong>
            </button>
          </div>
        </div>
      </div>
      <div class="col-sm-2 col-md-2  autocomplete-width autocomplete-field-container">
        <input matInput placeholder="Select Vehicle Model" class="form-control" name="vehicleTypeFilter"
          (ngModelChange)="setVehicleTypeFilter($event)" [(ngModel)]="vehicleTypeFilter" aria-label="Models"
          [matAutocomplete]="Models" [ngModelOptions]="{ standalone: true }" id="vehicleModel" />
        <mat-autocomplete #Models="matAutocomplete" [displayWith]="displayFnModel">
          <mat-option *ngFor="let model of modelList" [value]="model">
            {{ model.name }}
          </mat-option>
        </mat-autocomplete>
      </div>
      <div class="col-sm-2 col-md-2 autocomplete-width autocomplete-field-container">
        <input matInput placeholder="Search Vehicle" class="form-control" name="vehicleFilter"
          (ngModelChange)="setVehicleFilter($event)" [formControl]="vehicleMapFilter" [(ngModel)]="vehicleFilter"
          aria-label="Vehicle" [matAutocomplete]="Vehicles2" />
        <mat-autocomplete #Vehicles2="matAutocomplete" [displayWith]="displayFnvehicle">
          <mat-option *ngFor="let vehicle of selectVehicleData" [value]="vehicle">
            <div class="option-otr">
              <div class="option_span">{{ vehicle.licence_number }}</div>
              <div class="option_span">{{ vehicle.registration_number }}</div>
              <div class="option_span">{{ vehicle.display_name }}</div>
            </div>
          </mat-option>
        </mat-autocomplete>
      </div>
      <div class="col-sm-2 col-md-2 autocomplete-width autocomplete-field-container">
        <input matInput placeholder="Side Number" class="form-control" name="vehicleFilter"
          (ngModelChange)="setVehicleFilter($event)" [formControl]="vehicleMapFilter" [(ngModel)]="sideFilter"
          aria-label="Vehicle" [matAutocomplete]="Side2" />
        <mat-autocomplete #Side2="matAutocomplete" [displayWith]="displayFnside">
          <mat-option *ngFor="let vehicle of selectVehicleData" [value]="vehicle">
            <div class="option-otr">
              <div class="option_span">
                {{ vehicle.vehicle_identity_number }}
              </div>
            </div>
          </mat-option>
        </mat-autocomplete>
      </div>
    </div>
    <br />
    <div class="container">
      <div class="col-sm-2 col-md-2 autocomplete-width autocomplete-field-container">
        <label *ngIf="!hidden">Select driver</label>
        <input matInput placeholder="Select Driver" class="form-control" name="driverFilter"
          (ngModelChange)="setDriverFilter($event)" [formControl]="driverMapFilter" [(ngModel)]="driverFilter"
          aria-label="Drivers" [matAutocomplete]="Drivers" />
        <mat-autocomplete #Drivers="matAutocomplete" [displayWith]="displayFnDriver">
          <mat-option *ngFor="let driver of selectDriverData" [value]="driver">
            <span class="img-otr">
              <img style="vertical-align:middle;" aria-hidden src="{{
                    driver.profile_picture
                      ? apiUrl + driver.profile_picture+imageext
                      : '../../assets/img/noimage.jpg'
                  }}" height="25" alt="profile"/>
            </span>
            <div class="option-otr">
              <div class="option_span">
                <strong> Username:</strong> {{ driver.username }}
              </div>
              <div class="option_span" title="{{ driver.name }} &nbsp;{{ driver.surname }}">
                <strong>Name&Surname:</strong>{{ driver.name }} &nbsp;{{
                driver.surname
                }}
              </div>
              <div class="option_span">
                <strong>Display Name:</strong>{{ driver.display_name }}
              </div>
              <div class="option_span">
                <strong>vehicle Plate:</strong>{{
                driver.vehicle_id ? driver.vehicle_id.plate_number : "N/A"
                }}
              </div>
              <div class="option_span">
                <strong>Device Id:</strong>{{
                driver.device_id ? driver.device_id.unique_device_id : "N/A"
                }}
              </div>
            </div>
          </mat-option>
        </mat-autocomplete>
      </div>
      <div class="col-sm-2 autocomplete-width autocomplete-field-container">
        <label *ngIf="!hidden">Select driver group</label>
        <mat-select class="form-control" placeholder="Driver groups" (change)="changeDriverGroupsMap($event)">
          <mat-option value="All">All</mat-option>
          <mat-option *ngFor="let group of driverGroupData" [value]="group._id">{{group.name}}</mat-option>
        </mat-select>
      </div>
      <div class="col-sm-2 col-md-2 autocomplete-width autocomplete-field-container">
        <label *ngIf="!hidden">Select vehicle category</label>
        <mat-select  id="vehicleCategory" [(ngModel)]="vehicle_category_ids" placeholder="Vehicle Category" class="form-control" (selectionChange)="setMapFilter(mapFilterr)" multiple>
          <mat-option *ngFor="let vehicle of vehicleCategories" [value]="vehicle._id">{{vehicle.name}}
          </mat-option>
        </mat-select>
      </div>
      <div class="col-sm-2 autocomplete-width autocomplete-field-container" *ngIf="dtc">
        <label *ngIf="!hidden && dtc">Select company</label>
        <mat-select [(ngModel)]="companyIdFilter" placeholder="Company" class="form-control" multiple>
          <mat-option value="all" (click)="selectAllCompany()">All</mat-option>
          <mat-option (click)="companyManualSelect()" *ngFor="let company of companyData" [value]="company._id">
            {{company.company_name}}
          </mat-option>
        </mat-select>
      </div>

      <div *ngIf="!hidden">
        <div class="col-sm-2 col-md-2 autocomplete-width autocomplete-field-container">
          <label>Intervel in Minutes</label>
          <input type="number" class="form-control" placeholder="Intervel Minutes" [(ngModel)]="minutesM" />
        </div>
        <div class="col-sm-2 col-md-2 autocomplete-width autocomplete-field-container">
          <label>Intervel Limit in Minutes</label>
          <input type="number" class="form-control" placeholder="Intervel Minutes" [(ngModel)]="minutesLimitM" />
        </div>
      </div>
      <div class="col-sm-4 col-md-4" id="map_nav">
        <label *ngIf="!hidden">&nbsp</label>
        <ul class="nav nav-pills">
          <li><a (click)="setTripStatus(0)" style="background-color: rgb(59, 59, 253);"
              matTooltip="Booked">{{bookedLength}}</a></li>
          <li><a (click)="setVehicleStatusFilter('1')" style="background-color: rgb(198, 67, 67);"
              matTooltip="Paused">{{offlineLength}}</a></li>
          <li><a (click)="setVehicleStatusFilter('3')" style="background-color: rgb(41, 41, 41);"
              matTooltip="Logged">{{loggedLength}}</a></li>
          <li><a (click)="setVehicleStatusFilter('5')" style="background-color: rgb(67, 198, 79);"
              matTooltip="Free">{{ freeLength }}</a></li>
          <li><a (click)="setTripStatus(1)" style="background-color: rgb(77, 150, 89);"
              matTooltip="Accepted">{{ acceptedLength }}</a></li>
          <li><a (click)="setTripStatus(2)" style="background-color: rgb(67, 108, 79);"
              matTooltip="Almost free">{{ almostFreeLength }}</a></li>
          <li>
            <ng-container *ngIf="downloads && !vehicle_id && csvAcl">
              <span matTooltip="CSV"
                [ngStyle]="{'pointer-events':!csvList.length>0?'none':'unset','cursor':!csvList.length>0?'no-drop':'pointer'}">
                <img src="assets/img/csv.png" (click)="createCsv()" alt="csv"/>
              </span>
            </ng-container>
          </li>
          <li *ngIf="!hidden"><a (click)="changeMinues()" class="btn btn-sm btn-primary sort-black">Submit</a></li>
          <li><a (click)="reset()" class="btn btn-sm btn-primary sort-black"><i aria-hidden="true" class="fa fa-eraser"></i>Reset
              filters</a></li>
        </ul>
      </div>
    </div>
    <br />
  </div>
  <div class="container" *ngIf="showOrderTrack">
    <h1 class="title-set-map">Shift Tracking</h1>
    <div class="col-sm-2 col-md-2 autocomplete-field-container">
      <label>Start date</label>
      <input [(ngModel)]="selectedMoment" name="start_date" [owlDateTimeTrigger]="dtPicker1" [owlDateTime]="dtPicker1"
        placeholder="Start Date" class="form-control" [max]="max" (ngModelChange)="clearEndDate()" />
      <owl-date-time #dtPicker1 (click)="clearEndDate()"></owl-date-time>
    </div>

    <div class="col-sm-2 col-md-2 autocomplete-field-container">
      <label>End date</label>
      <input [(ngModel)]="selectedMoment1" name="end_date" [min]="selectedMoment" [max]="max2"
        [owlDateTimeTrigger]="dtPicker2" [owlDateTime]="dtPicker2" placeholder="End Date" class="form-control" />
      <owl-date-time #dtPicker2></owl-date-time>
    </div>

    <div class="col-sm-2 col-md-2 autocomplete-field-container">
      <label>Vehicle side number</label>
      <input matInput placeholder="Side number" class="form-control" name="vehicleFilter" [formControl]="side_no"
        [(ngModel)]="side" (ngModelChange)="showCar($event)" aria-label="Vehicle" [matAutocomplete]="Side" />
      <mat-autocomplete #Side="matAutocomplete" [displayWith]="displayFnside">
        <mat-option *ngFor="let vehicle of selectVehicleData2" [value]="vehicle">
          {{ vehicle.vehicle_identity_number }}
        </mat-option>
      </mat-autocomplete>
      <span class="text-danger">{{ message }}</span>
    </div>
    <div class="col-sm-2 autocomplete-width autocomplete-field-container" *ngIf="dtc">
      <label>Select company</label>
      <mat-select [(ngModel)]="companyidFilter" placeholder="Company" class="form-control" multiple>
        <mat-option value="all" (click)="selectAllCompany()">All</mat-option>
        <mat-option (click)="companyManualSelect()" *ngFor="let company of companyData" [value]="company._id">
          {{company.company_name}}
        </mat-option>
      </mat-select>
    </div>
    <div class="col-sm-1 text-right">
      <label></label>
      <button type="button" (click)="trackOrder()" [disabled]="orderButton" class="btn btn-block btn-primary blue">
        Track</button><br />
    </div>
    <div class="col-sm-1 text-right">
      <label></label>
      <button class="btn btn-block btn-primary red" (click)="reset()">
        Reset
      </button>
    </div>
  </div>
</div>
<div *ngIf="showCover" class="cover">
  <img class="loading_indicator" src="assets/img/loading.gif" alt="loader"/>
</div>
<div class="col-sm-12 autocomplete-field-container">
  <span class="location-error text-center">{{
    locationmsg == "No" ? "No location found" : ""
    }}</span>
</div>
<div>
  <ngui-map class="maping" (mapReady$)="onMapReady($event)" [center]="center" [zoom]="10"
    [zoomControlOptions]="{ position: 'LEFT_TOP' }" [fullscreenControl]="true"
    [fullscreenControlOptions]="{ position: 'LEFT_TOP' }" (click)="log($event)" [scrollwheel]="true">
    <marker (click)="onOrderMarkerClick($event)" *ngIf="startmarker" [position]="startmarker" [icon]="{
        url: 'assets/img/marker-red.png',
        anchor: [40, 40],
        size: [40, 40],
        scaledSize: [40, 40]
      }" title="Starting point"></marker>
    <marker (click)="onOrderMarkerClick($event)" *ngIf="destinationmarker" [position]="destinationmarker" [icon]="{
        url: 'assets/img/loc_icon.png',
        anchor: [40, 40],
        size: [40, 40],
        scaledSize: [40, 40]
      }"  title="Ending point"></marker>
    <info-window id="vehicleTrackwindow" style="margin:0px;padding:0px;">
      <p style="font-size:medium;"><strong>Trip Information</strong></p>
      <br />Speed : {{ ordermarker.speed?ordermarker.speed:'NA' }}
      <br />Order status: {{ ordermarker.order }} <br />Timestamp :
      {{ ordermarker.date }} <br />GPS :
      {{ ordermarker.is_gps_on == true ? "ON" : "OFF" }} <br />Network :
      {{ ordermarker.is_internet_on == true ? "ON" : "OFF" }} <br />GPS Accuracy:{{
    ordermarker.accuracy ? ordermarker.accuracy : "NA"
    }}
      <br />Battery:{{ ordermarker.battery ? ordermarker.battery : "NA" }}
    </info-window>
    <marker *ngFor="let pos of positions1" [position]="pos" [icon]="{
      url: '/assets/img/map/limo_black_car_alone.png',
      anchor: [40, 40],
      size: [40, 40],
      scaledSize: [40, 40]
    }" [geoFallbackPosition]="[43.73154789999999, -79.7449296972229]" draggable="false">
    </marker>
    <marker *ngFor="let pos of positions3" [position]="pos" [icon]="{
      url: '/assets/img/map/limo_black_car_alone.png',
      anchor: [40, 40],
      size: [40, 40],
      scaledSize: [40, 40]
    }" [geoFallbackPosition]="[43.73154789999999, -79.7449296972229]" draggable="false">
    </marker>
    <info-window id="iw" style="min-width: 180px;">
      <div *ngIf="marker.display">
        <p style="float: left">
          <strong>{{ marker.vehicle_id ? marker.vehicle_id : "NA" }}</strong>
          <span>{{ marker.vehicle_model ? marker.vehicle_model : "" }}</span>
        </p>
        <p style="float: right;">
          <i aria-hidden="true" class="fa fa-map-marker"></i>&nbsp;<small><strong><a id="clicka" *ngIf="dtc">Shift
                track</a></strong></small>
        </p>
        <div style="clear: both;"></div>
        <p *ngIf="marker.shift_start">
          <small><strong>Last login:</strong>
            {{
          marker.shift_start ? (marker.shift_start | date: "h:mm:ss a") : "NA"
          }}
            {{ since(marker.shift_start) }}</small>
        </p>
        <p style="float: left;">
          <small><i aria-hidden="true" class="fa fa-car"></i>&nbsp;{{marker.status}}</small>
        </p>
        <p style="float:right" *ngIf="!marker.shift_end">
          <span [ngStyle]="{'display': 'inline-block', 'color': iconColor(marker.updated_at)}"><i aria-hidden="true"
              class="fa fa-wifi"></i></span>
          <small>{{ since(marker.updated_at) }}</small>
        </p>
        <div style="clear: both;"></div>
        <p *ngIf="!marker.shift_end" style="float:left;">
          <img style="display: inline-block; margin-right: 3px;" src="/assets/img/map/speedometer_icon.png" alt="speed"/><small>{{
          marker.speed !== 0 ? marker.speed + " Kmph" : "NA" }}
          </small>
        </p>
        <p *ngIf="!marker.shift_end" style="float:right;">
          <img style="display:inline-block; margin-right: 3px;" src="/assets/img/map/battery_level_icon.png" alt="battery"/><small>{{
          marker.battery ? (marker.battery | number: 0) : "NA"
          }}&#37;</small>
        </p>
        <p *ngIf="!marker.shift_end" style="margin-left: auto; margin-right: auto; text-align:center;">
          <img style="display:inline-block; margin-right: 4px;" src="/assets/img/map/gps_strength_icon.png" alt="gps"/><small>{{
          marker.gps_strength ? (marker.gps_strength | number: 0) : "NA"
          }}m</small>
        </p>
        <p *ngIf="marker.shift_end">
          <small><strong>Last logout:</strong>
            {{
          marker.shift_end ? (marker.shift_end | date: "h:mm:ss a") : "NA"
          }}
            {{ since(marker.shift_end) }}</small>
        </p>
        <div style="clear:both;"></div>

        <p style="float:left;">
          <small><strong>{{ marker.driver_name ? marker.driver_name : "NA" }}</strong></small>
        </p>
        <p style="float:right;">
          <small><strong>{{ marker.emp_id ? marker.emp_id : "NA" }}</strong></small>
        </p>
        <p style="margin-left: auto; margin-right: auto; text-align:center;">
          <small>{{ marker.driverphone ? marker.driverphone : "NA" }}</small>
        </p>
        <div style="clear: both;"></div>
        <p *ngIf="marker.pickup_location" style="display: inline-block;font-size: 8px"><strong>PICKUP :</strong>{{
          marker.pickup_location ? marker.pickup_location : ""
          }}
        </p>
      </div>
    </info-window>
  </ngui-map>
</div>
<div id="vehicleModel"></div>
<script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/2.0.4/socket.io.js"></script>
<script>
  var socket = io("https://apisockdispatcher.mobilityae.com:7092");
  socket.on("Send User Location", function (data) {
    socket.emit("Send User Location", data);
  });
</script>
<style>
  .error {
    color: red;
    font-size: 11px;
  }
</style>